#!/usr/bin/env python
from __future__ import division
import sys
import string

import xml.dom.minidom
import xml.dom.ext

filename = "elements.csv"

doc = xml.dom.minidom.Document()
elementsE = doc.createElement('elements');doc.appendChild(elementsE)

infile = open(filename,"r")
filetext = infile.read()
lines = filetext.splitlines()
for line in lines:
	elementE = doc.createElement('element');elementsE.appendChild(elementE)
	values = line.split(",")
	if len(values) <32:
		values.extend((32-len(values))*[''])
	
	print values
	
	elementE.setAttribute('Z',values[0])

	nameE = doc.createElement('name'); elementE.appendChild(nameE)
	nameE.appendChild(doc.createTextNode(values[1]))
	
	symbolE = doc.createElement('symbol'); elementE.appendChild(symbolE)
	symbolE.appendChild(doc.createTextNode(values[2]))
	
	if(values[3] != 'NA'):
		rad = float(values[3])*10**(-12)
		radiusE = doc.createElement('radius'); elementE.appendChild(radiusE)
		radiusE.appendChild(doc.createTextNode(str(rad)))
		if(values[4]!=''): radiusE.setAttribute('note',values[4])
		radiusE.setAttribute('set','neutral')
		radiusE.setAttribute('charge','0')
	
	svals = [0,.1,.2,.3,.4,.5,.6,.7,.8,.9,1.0,1.1,1.2]
	base=5
	end=17
	if(values[base] != ''):
		print "sf"
		sfE = doc.createElement('scatteringfactor'); elementE.appendChild(sfE)
		sfE.setAttribute('charge','0')
		sfE.setAttribute('set','neutral')
		for i in range(base,end) :
			if(values[i] != ""):
				s = svals[i-base]*10**(10)
				datapointE = doc.createElement('data'); sfE.appendChild(datapointE)
				sE = doc.createElement('s');datapointE.appendChild(sE)
				sE.appendChild(doc.createTextNode(str(s)))
				asfE = doc.createElement('value');datapointE.appendChild(asfE)
				asfE.appendChild(doc.createTextNode(values[i]))

		
	base=19
	end=32
	if(values[18] != ''):
		print "sf2"
		sfE = doc.createElement('scatteringfactor'); elementE.appendChild(sfE)
		sfE.setAttribute('charge',values[18])
		#sfE.setAttribute('set','neutral')
		for i in range(base,end) :
			if(values[i] != ""):
				s = svals[i-base]*10**(10)
				datapointE = doc.createElement('data'); sfE.appendChild(datapointE)
				sE = doc.createElement('s');datapointE.appendChild(sE)
				sE.appendChild(doc.createTextNode(str(s)))
				asfE = doc.createElement('value');datapointE.appendChild(asfE)
				asfE.appendChild(doc.createTextNode(values[i]))
				
outfile = open("elements.xml","w")
xml.dom.ext.PrettyPrint(doc,outfile)
outfile.close()
