#!/usr/bin/env python
from __future__ import division
import sys
import string

import xml.dom.minidom
import xml.dom.ext


filenames = sys.argv[1:]

doc = xml.dom.minidom.Document()
spacegroupsE = doc.createElement('spacegrouplist');doc.appendChild(spacegroupsE)

for filename in filenames:

    print filename
    infile = open(filename,"r")

    filetext = infile.read()
    lines = filetext.splitlines()
    
    begin = filetext.find("+-",0)
    begin = filetext.find("| Space group",0)
    end = filetext.find(",",begin)
    
    
    sg_name = filetext[begin+len("| Space group"):end] #.split(" ")[3:]


    begin = filetext.find("space group number",0)
    end = filetext.find(",",begin)
    
    sg_num = filetext[begin:end].split(" ")[-1];
    
    begin =  filetext.find("Bravais translation",end)
    end = filetext.find("|",begin)
    
    print filetext[begin:end].split()
    
    begin = filetext.find("Translation vectors :",end)
    end = filetext.find("|",begin)    
    
    sg_transvects = filetext[begin:end]
    
    sg_transvects = "("+sg_transvects.split(":")[-1]+")"
    sg_transvects = eval(sg_transvects)

    print sg_name
    print sg_num
    #print sg_transvects
    #print eval(sg_transvects)
    
    begin = filetext.find("+-",0)
    begin = filetext.find("| Space group",0)
    end = filetext.find(",",begin)
    
    
    sg_name = filetext[begin+len("| Space group"):end] #.split(" ")[3:]


    begin = filetext.find("space group number",0)
    end = filetext.find(",",begin)
    
    sg_num = filetext[begin:end].split(" ")[-1];
    
    begin =  filetext.find("Bravais translation",end)
    end = filetext.find("|",begin)
    
    print filetext[begin:end].split()
    
    begin = filetext.find("Translation vectors :",end)
    end = filetext.find("|",begin)    
    
    sg_transvects = filetext[begin:end]
    
    sg_transvects = "("+sg_transvects.split(":")[-1]+")"
    sg_transvects = eval(sg_transvects)
    if sg_transvects == ():
        sg_transvects = (('0.0','0.0','0.0'),)

    print sg_name
    print sg_num
    #print sg_transvects
    #print eval(sg_transvects)



    begin = filetext.find("R(11)",0)
    end = filetext.find("|",begin)   
 
    begin = filetext.find("|",end+1)
    end = filetext.find("+",begin)

    sg_transforms = filetext[begin:end]
   

    sg_transforms =    sg_transforms.splitlines()
   
    print sg_transforms
    
    if filetext.find("Non centrosymmetric space group") >0:
        print "non centrosym"
    else:
        sg_transforms = sg_transforms + ["|-1.0   0.0   0.0   0.0  -1.0   0.0   0.0   0.0  -1.0    0.000  0.000  0.000  |",]
    
    print sg_transforms

    sg_num = int(sg_num)
    
    if   sg_num < 3:
        crystal_system = "triclinic"
    elif sg_num < 16:
        crystal_system = "monoclinic"
    elif sg_num < 75:
        crystal_system = "orthorhombic"
    elif sg_num< 143:
        crystal_system = "tetragonal"
    elif sg_num< 168:
        crystal_system = "trigonal"
    elif sg_num< 195:
        crystal_system = "hexagonal"
    else:
        crystal_system = "cubic"

    print crystal_system

    #doc = xml.dom.minidom.Document()
    root = doc.createElement('spacegroup'); spacegroupsE.appendChild(root)
    root.setAttribute('id',str(sg_num))
    #root.setAttribute('system',crystal_system)
    
    nameE = doc.createElement('name'); root.appendChild(nameE)
    nameE.appendChild(doc.createTextNode(sg_name.strip()))

    systemE = doc.createElement('system'); root.appendChild(systemE)
    systemE.appendChild(doc.createTextNode(crystal_system))

    translationsE = doc.createElement('translationlist')
    root.appendChild(translationsE)
    for vect in sg_transvects:
        translationE = doc.createElement('translation')
        translationsE.appendChild(translationE)
        
        coords = str(vect)[1:-1].split(',')
        uE = doc.createElement('u'); translationE.appendChild(uE)
        uE.appendChild(doc.createTextNode(str(eval(coords[0]))))
        vE = doc.createElement('v'); translationE.appendChild(vE)
        vE.appendChild(doc.createTextNode(str(eval(coords[1]))))
        wE = doc.createElement('w'); translationE.appendChild(wE)
        wE.appendChild(doc.createTextNode(str(eval(coords[2]))))
    
    transformsE = doc.createElement('transformlist')
    root.appendChild(transformsE)
    for line in sg_transforms:
        if line != ' ':
            values = line.split()
            transformE = doc.createElement('transform'); transformsE.appendChild(transformE)
            for val in values:
                if val.find("|") == 0 and len(val)>1:
                    val = val[1:]
                if val.find("|") < 0 :
                    valE = doc.createElement('val'); transformE.appendChild(valE)
                    valE.appendChild(doc.createTextNode(str(eval(val))))
                
    infile.close()

    #outfile = open("xml/"+string.zfill(sg_num,3),"w")
    #xml.dom.ext.PrettyPrint(doc,outfile)
    #outfile.close()

outfile = open("spacegrouplist.xml","w")
xml.dom.ext.PrettyPrint(doc,outfile)
outfile.close()
